/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.seguridad;

import com.rjconsultores.ventaboletos.entidad.Sistema;
import com.rjconsultores.ventaboletos.service.SistemaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import java.util.Calendar;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Textbox;

/**
 *
 * @author rodrigo
 */
@Controller("editarSistemaController")
@Scope("prototype")
public class EditarSistemaController extends MyGenericForwardComposer {

    @Autowired
    private SistemaService sistemaService;
    private Sistema sistema;
    private MyListbox sistemaList;
    private Textbox txtNome;
    private Button btnApagar;
    private static Logger log = Logger.getLogger(EditarSistemaController.class);

    public Sistema getSistema() {
        return sistema;
    }

    public void setSistema(Sistema sistema) {
        this.sistema = sistema;
    }

    public Textbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(Textbox txtNome) {
        this.txtNome = txtNome;
    }

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        sistema = (Sistema) Executions.getCurrent().getArg().get("sistema");
        sistemaList = (MyListbox) Executions.getCurrent().getArg().get("sistemaList");

        if (sistema.getSistemaId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        }

        txtNome.focus();
    }

    public void onClick$btnSalvar(Event ev) {
        txtNome.getText();

        try {
            sistema.setActivo(Boolean.TRUE);
            sistema.setFecmodif(Calendar.getInstance().getTime());
            sistema.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

            if (sistema.getSistemaId() == null) {
                sistemaService.suscribir(sistema);
                sistemaList.addItem(sistema);
            } else {
                sistemaService.actualizacion(sistema);
                sistemaList.updateItem(sistema);
            }

            Messagebox.show(
                    Labels.getLabel("editarSistemaController.MSG.suscribirOK"),
                    Labels.getLabel("editarSistemaController.window.title"),
                    Messagebox.OK, Messagebox.INFORMATION);

            closeWindow();
        } catch (Exception ex) {
            log.error(ex);
        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarSistemaController.MSG.borrarPergunta"),
                    Labels.getLabel("editarSistemaController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {
                sistemaService.borrar(sistema);

                Messagebox.show(
                        Labels.getLabel("editarSistemaController.MSG.borrarOK"),
                        Labels.getLabel("editarSistemaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                sistemaList.removeItem(sistema);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }
}
